<?PHP
/*-----------------------------------------------------------------------**
---------------------------------------------------------------------------
IPM (Incyte Project Manager)
PHP based project tracking tool 
Copyright (c) 2001 by phlux

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
---------------------------------------------------------------------------
**-----------------------------------------------------------------------*/

/*|||||||||||||||||  Basic Configuration  ||||||||||||||||||||// 
$page_title: goes in the <title> tags for every page
$version: self explanitory
$listdisplay: this determines what is displayed for a user on the task lists
	-options are "lastname", "firstname", or "username"
$ipmaddress: The address that IPM notifications will come from 
$pathtofortune: enter the path to the fortune binary
	-usually /usr/games/fortune. leave blank for no fortunes.
	**NOTE** The fortune option is a little buggy, in that it
	can cause the header to display improperly due to large
	fortunes trying to squeeze into the limited amound of space
	in the header <table> Because of this it is off by default
	but if turned on, will cause no real damage.
$unauthorizedmessage: The message a user sees when he fails or cancels login
$db_servername: The hostname of your MySQL server, usually localhost
$db_username: The authorized username for the SQL database you plan to use
$db_password: That user's password
$db_dbname: The name of the database to use, usually IPM
$stylesheet_url: The relative or absolute path to your style sheet
	-defaults to "style/default.css"
||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*/
$page_title="Incyte Project Manager - ";
$version="0.9.4";
$listdisplay="firstname";
$ipmaddress="IPM@udpviper.com"; 
$pathtofortune="";
$unauthorizedmessage="You have to put in a password that works, you cockroach!";
$db_servername="localhost";
$db_username="mysqlusername";
$db_password="mysqlpassword";
$db_dbname="IPM";
$stylesheet_url="style/default.css";


/*|||||||||||||||||  Basic Configuration  ||||||||||||||||||||// 
$use_dlap: New feature as of version 0.9.3. If set to true IPM will use a
	mysql-ldap hybrid user management system.  All users still need
	to be added to the mysql database through the administration
	interface.  But only users that already exist in your LDAP
	database can be added to the IPM user database.  Further, while
	LDAP support is enabled the password stored by IPM will NOT be
	used, but the LDAP authentication will be used instead. Under
	no circumstances will IPM modify your LDAP database.
$ldap_server: The hostname or IP of your LDAP server.
$ldap_port: The port number to connect to on the LDAP server.
	The default port for lDAP is 389.
$ldap_dn: The base DN of your LDAP server.
$ldap_attr: The key attribute to search for.  For instance, if users are
	stored in your LDAP database with the DN cn=someone,dn=domain,dn=com
	then ldap_attr should be "cn".
||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*/
$use_ldap=false;
$ldap_server="ldap.udpviper.com";
$ldap_port=389;
$ldap_dn="dc=udpviper,dc=com";
$ldap_attr="cn";
?>
